import argparse

parser = argparse.ArgumentParser()
parser.add_argument('-n', '--num-types', default=50, type=int, help='The number of types to use')
parser.add_argument('-s', '--self-comparisons', default=10, type=int, help='The number of times operator== is called for each type with itself')
parser.add_argument('-o', '--other-comparisons', default=2, type=int, help='The number of times operator== is called for each type with every other type')
args = parser.parse_args()

n = args.num_types
self_comparisons = args.self_comparisons
other_comparisons = args.other_comparisons
print('Generating main with {} types, {} self-comparisons and {} sets of other-comparisons'.format(n, self_comparisons, other_comparisons))

with open('main.cpp', 'w') as outfile:
    outfile.write('#include "types.h"\n\nint main()\n{\n')

    for i in range(n):
        #outfile.write('  T{} val{}({});\n'.format(i,i,i))
        outfile.write('  T{} val{} {{{}}};\n'.format(i,i,i))

    outfile.write('\n  int result = 0;\n\n')

    for i in range(n):
        for j in range(self_comparisons):
            outfile.write('  result += int(val{} == val{});\n'.format(i, i))
    outfile.write('\n')

    for i in range(n):
        for k in range(i):
            for j in range(other_comparisons):
                outfile.write('  result += int(val{} == val{});\n'.format(i, k))
    outfile.write('\n  return result;\n}\n')

