set datafile separator ","
set style fill solid
set xlabel "Self-comparisons per type"
unset ylabel
set y2label "Compilation time (seconds)" rotate by -90
unset ytics
set y2tics
set key top left

set xrange [0:51]

# Palettes from https://github.com/Gnuplotting/gnuplot-palettes
set style line 1 lc rgb "#E41A1C" linetype 1 linewidth 2 pointtype 7 pointsize 1.5
set style line 2 lc rgb "#377EB8" linetype 1 linewidth 2 pointtype 7 pointsize 1.5
set style line 3 lc rgb "#4DAF4A" linetype 1 linewidth 2 pointtype 7 pointsize 1.5
set style line 4 lc rgb "#984EA3" linetype 1 linewidth 2 pointtype 7 pointsize 1.5
set style line 5 lc rgb "#FF7F00" linetype 1 linewidth 2 pointtype 7 pointsize 1.5

set term pngcairo transparent truecolor

set output 'hidden_friend_off.png'
set title "Using normal free functions"
plot "compile_seconds_msvc_0_10.txt" with linespoints linestyle 1 title "10 types", \
     "compile_seconds_msvc_0_20.txt" with linespoints linestyle 2 title "20 types", \
     "compile_seconds_msvc_0_30.txt" with linespoints linestyle 3 title "30 types", \
     "compile_seconds_msvc_0_40.txt" with linespoints linestyle 4 title "40 types", \
     "compile_seconds_msvc_0_50.txt" with linespoints linestyle 5 title "50 types", \

set output 'hidden_friend_on.png'
set title "Using the 'hidden friend' idiom'"
plot "compile_seconds_msvc_1_10.txt" with linespoints linestyle 1 title "10 types", \
     "compile_seconds_msvc_1_20.txt" with linespoints linestyle 2 title "20 types", \
     "compile_seconds_msvc_1_30.txt" with linespoints linestyle 3 title "30 types", \
     "compile_seconds_msvc_1_40.txt" with linespoints linestyle 4 title "40 types", \
     "compile_seconds_msvc_1_50.txt" with linespoints linestyle 5 title "50 types", \

set output 'hidden_friend_compare.png'
set title "50 types using hidden friends vs normal functions"
plot "compile_seconds_msvc_0_50.txt" with linespoints linestyle 1 title "Normal function", \
     "compile_seconds_msvc_1_50.txt" with linespoints linestyle 2 title "Hidden friend", \

